diff -r f3e24bd4d57e trytond/modules/sale/sale.py
--- a/trytond/modules/sale/sale.py	Tue Sep 11 15:23:08 2012 +0200
+++ b/trytond/modules/sale/sale.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1110,359 +1000,277 @@
                     'an "account Revenue" default property!',
             })
 
-    def init(self, module_name):
-        super(SaleLine, self).init(module_name)
+    @classmethod
+    def __register__(cls, module_name):
+        super(SaleLine, cls).__register__(module_name)
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
         # Migration from 1.0 comment change into note
         if table.column_exist('comment'):
-            cursor.execute('UPDATE "' + self._table + '" SET note = comment')
+            cursor.execute('UPDATE "' + cls._table + '" SET note = comment')
             table.drop_column('comment', exception=True)
 
         # Migration from 2.4: drop required on sequence
         table.not_null_action('sequence', action='remove')
 
-    def default_type(self):
+    @staticmethod
+    def default_type():
         return 'line'
 
-    def default_unit_digits(self):
+    @staticmethod
+    def default_unit_digits():
         return 2
 
-    def on_change_with_unit_digits(self, vals):
-        uom_obj = Pool().get('product.uom')
-        if vals.get('unit'):
-            uom = uom_obj.browse(vals['unit'])
-            return uom.digits
+    def on_change_with_unit_digits(self, name=None):
+        if self.unit:
+            return self.unit.digits
         return 2
 
-    def get_unit_digits(self, ids, name):
-        res = {}
-        for line in self.browse(ids):
-            if line.unit:
-                res[line.id] = line.unit.digits
-            else:
-                res[line.id] = 2
-        return res
+    def get_move_done(self, name):
+        Uom = Pool().get('product.uom')
+        done = True
+        if not self.product:
+            return True
+        if self.product.type == 'service':
+            return True
+        skip_ids = set(x.id for x in self.moves_ignored)
+        skip_ids.update(x.id for x in self.moves_recreated)
+        quantity = self.quantity
+        for move in self.moves:
+            if move.state != 'done' \
+                    and move.id not in skip_ids:
+                done = False
+                break
+            quantity -= Uom.compute_qty(move.uom, move.quantity, self.unit)
+        if done:
+            if quantity > 0.0:
+                done = False
+        return done
 
-    def get_move_done(self, ids, name):
-        uom_obj = Pool().get('product.uom')
-        res = {}
-        for line in self.browse(ids):
-            val = True
-            if not line.product:
-                res[line.id] = True
-                continue
-            if line.product.type == 'service':
-                res[line.id] = True
-                continue
-            skip_ids = set(x.id for x in line.moves_ignored)
-            skip_ids.update(x.id for x in line.moves_recreated)
-            quantity = line.quantity
-            for move in line.moves:
-                if move.state != 'done' \
-                        and move.id not in skip_ids:
-                    val = False
-                    break
-                quantity -= uom_obj.compute_qty(move.uom, move.quantity,
-                        line.unit)
-            if val:
-                if quantity > 0.0:
-                    val = False
-            res[line.id] = val
-        return res
+    def get_move_exception(self, name):
+        skip_ids = set(x.id for x in self.moves_ignored)
+        skip_ids.update(x.id for x in self.moves_recreated)
+        for move in self.moves:
+            if move.state == 'cancel' \
+                    and move.id not in skip_ids:
+                return True
+        return False
 
-    def get_move_exception(self, ids, name):
-        res = {}
-        for line in self.browse(ids):
-            val = False
-            skip_ids = set(x.id for x in line.moves_ignored)
-            skip_ids.update(x.id for x in line.moves_recreated)
-            for move in line.moves:
-                if move.state == 'cancel' \
-                        and move.id not in skip_ids:
-                    val = True
-                    break
-            res[line.id] = val
-        return res
-
-    def _get_tax_rule_pattern(self, party, vals):
+    def _get_tax_rule_pattern(self):
         '''
         Get tax rule pattern
+        '''
+        return {}
 
-        :param party: the BrowseRecord of the party
-        :param vals: a dictionary with value from on_change
-        :return: a dictionary to use as pattern for tax rule
-        '''
-        res = {}
-        return res
-
-    def _get_context_sale_price(self, product, vals):
+    def _get_context_sale_price(self):
         context = {}
-        if vals.get('_parent_sale.currency'):
-            context['currency'] = vals['_parent_sale.currency']
-        if vals.get('_parent_sale.party'):
-            context['customer'] = vals['_parent_sale.party']
-        if vals.get('_parent_sale.sale_date'):
-            context['sale_date'] = vals['_parent_sale.sale_date']
-        if vals.get('unit'):
-            context['uom'] = vals['unit']
+        if self.sale:
+            if self.sale.currency:
+                context['currency'] = self.sale.currency.id
+            if self.sale.party:
+                context['customer'] = self.sale.party.id
+            if self.sale.sale_date:
+                context['sale_date'] = self.sale.sale_date
+        if self.unit:
+            context['uom'] = self.unit.id
         else:
-            context['uom'] = product.sale_uom.id
+            context['uom'] = self.product.sale_uom.id
         return context
 
-    def on_change_product(self, vals):
-        pool = Pool()
-        party_obj = pool.get('party.party')
-        product_obj = pool.get('product.product')
-        tax_rule_obj = pool.get('account.tax.rule')
+    def on_change_product(self):
+        Product = Pool().get('product.product')
 
-        if not vals.get('product'):
+        if not self.product:
             return {}
         res = {}
 
         party = None
         party_context = {}
-        if vals.get('_parent_sale.party'):
-            party = party_obj.browse(vals['_parent_sale.party'])
+        if self.sale and self.sale.party:
+            party = self.sale.party
             if party.lang:
                 party_context['language'] = party.lang.code
 
-        product = product_obj.browse(vals['product'])
-
-        with Transaction().set_context(
-                self._get_context_sale_price(product, vals)):
-            res['unit_price'] = product_obj.get_sale_price([product.id],
-                    vals.get('quantity') or 0)[product.id]
+        with Transaction().set_context(self._get_context_sale_price()):
+            res['unit_price'] = Product.get_sale_price([self.product],
+                    self.quantity or 0)[self.product.id]
             if res['unit_price']:
                 res['unit_price'] = res['unit_price'].quantize(
-                    Decimal(1) / 10 ** self.unit_price.digits[1])
+                    Decimal(1) / 10 ** self.__class__.unit_price.digits[1])
         res['taxes'] = []
-        pattern = self._get_tax_rule_pattern(party, vals)
-        for tax in product.customer_taxes_used:
+        pattern = self._get_tax_rule_pattern()
+        for tax in self.product.customer_taxes_used:
             if party and party.customer_tax_rule:
-                tax_ids = tax_rule_obj.apply(party.customer_tax_rule, tax,
-                        pattern)
+                tax_ids = party.customer_tax_rule.apply(tax, pattern)
                 if tax_ids:
                     res['taxes'].extend(tax_ids)
                 continue
             res['taxes'].append(tax.id)
         if party and party.customer_tax_rule:
-            tax_ids = tax_rule_obj.apply(party.customer_tax_rule, None,
-                    pattern)
+            tax_ids = party.customer_tax_rule.apply(None, pattern)
             if tax_ids:
                 res['taxes'].extend(tax_ids)
 
-        if not vals.get('description'):
+        if not self.description:
             with Transaction().set_context(party_context):
-                res['description'] = product_obj.browse(product.id).rec_name
+                res['description'] = Product(self.product.id).rec_name
 
-        category = product.sale_uom.category
-        if not vals.get('unit') \
-                or vals.get('unit') not in [x.id for x in category.uoms]:
-            res['unit'] = product.sale_uom.id
-            res['unit.rec_name'] = product.sale_uom.rec_name
-            res['unit_digits'] = product.sale_uom.digits
+        category = self.product.sale_uom.category
+        if not self.unit or self.unit not in category.uoms:
+            res['unit'] = self.product.sale_uom.id
+            res['unit.rec_name'] = self.product.sale_uom.rec_name
+            res['unit_digits'] = self.product.sale_uom.digits
 
-        vals = vals.copy()
-        vals['unit_price'] = res['unit_price']
-        vals['type'] = 'line'
-        res['amount'] = self.on_change_with_amount(vals)
+        self.unit_price = res['unit_price']
+        self.type = 'line'
+        res['amount'] = self.on_change_with_amount()
         return res
 
-    def on_change_with_product_uom_category(self, values):
-        pool = Pool()
-        product_obj = pool.get('product.product')
-        if values.get('product'):
-            product = product_obj.browse(values['product'])
-            return product.default_uom_category.id
+    def on_change_with_product_uom_category(self, name=None):
+        if self.product:
+            return self.product.default_uom_category.id
 
-    def get_product_uom_category(self, ids, name):
-        categories = {}
-        for line in self.browse(ids):
-            if line.product:
-                categories[line.id] = line.product.default_uom_category.id
-            else:
-                categories[line.id] = None
-        return categories
+    def on_change_quantity(self):
+        Product = Pool().get('product.product')
 
-    def on_change_quantity(self, vals):
-        product_obj = Pool().get('product.product')
-
-        if not vals.get('product'):
+        if not self.product:
             return {}
         res = {}
 
-        product = product_obj.browse(vals['product'])
-
         with Transaction().set_context(
-                self._get_context_sale_price(product, vals)):
-            res['unit_price'] = product_obj.get_sale_price([vals['product']],
-                    vals.get('quantity') or 0)[vals['product']]
+                self._get_context_sale_price()):
+            res['unit_price'] = Product.get_sale_price([self.product],
+                self.quantity or 0)[self.product.id]
             if res['unit_price']:
                 res['unit_price'] = res['unit_price'].quantize(
-                    Decimal(1) / 10 ** self.unit_price.digits[1])
+                    Decimal(1) / 10 ** self.__class__.unit_price.digits[1])
         return res
 
-    def on_change_unit(self, vals):
-        return self.on_change_quantity(vals)
+    def on_change_unit(self):
+        return self.on_change_quantity()
 
-    def on_change_with_amount(self, vals):
-        currency_obj = Pool().get('currency.currency')
-        if vals.get('type') == 'line':
-            currency = vals.get('_parent_sale.currency')
-            if currency and isinstance(currency, (int, long)):
-                currency = currency_obj.browse(vals['_parent_sale.currency'])
-            amount = Decimal(str(vals.get('quantity') or '0.0')) * \
-                    (vals.get('unit_price') or Decimal('0.0'))
+    def on_change_with_amount(self):
+        if self.type == 'line':
+            currency = self.sale.currency if self.sale else None
+            amount = Decimal(str(self.quantity or '0.0')) * \
+                (self.unit_price or Decimal('0.0'))
             if currency:
-                return currency_obj.round(currency, amount)
+                return currency.round(amount)
             return amount
         return Decimal('0.0')
 
-    def get_amount(self, ids, name):
-        currency_obj = Pool().get('currency.currency')
-        res = {}
-        for line in self.browse(ids):
-            if line.type == 'line':
-                res[line.id] = currency_obj.round(line.sale.currency,
-                        Decimal(str(line.quantity)) * line.unit_price)
-            elif line.type == 'subtotal':
-                res[line.id] = Decimal('0.0')
-                for line2 in line.sale.lines:
-                    if line2.type == 'line':
-                        res[line.id] += currency_obj.round(line2.sale.currency,
-                                Decimal(str(line2.quantity)) *
-                                        line2.unit_price)
-                    elif line2.type == 'subtotal':
-                        if line.id == line2.id:
-                            break
-                        res[line.id] = Decimal('0.0')
-            else:
-                res[line.id] = Decimal('0.0')
-        return res
+    def get_amount(self, name):
+        if self.type == 'line':
+            return self.sale.currency.round(
+                Decimal(str(self.quantity)) * self.unit_price)
+        elif self.type == 'subtotal':
+            amount = Decimal('0.0')
+            for line2 in self.sale.lines:
+                if line2.type == 'line':
+                    amount += line2.sale.currency.round(
+                        Decimal(str(line2.quantity)) * line2.unit_price)
+                elif line2.type == 'subtotal':
+                    if self == line2:
+                        break
+                    amount = Decimal('0.0')
+            return amount
+        return Decimal('0.0')
 
-    def get_warehouse(self, ids, name):
-        result = {}
-        for line in self.browse(ids):
-            result[line.id] = line.sale.warehouse.id
-        return result
+    def get_warehouse(self, name):
+        return self.sale.warehouse.id
 
-    def get_from_location(self, ids, name):
-        result = {}
-        for line in self.browse(ids):
-            if line.quantity >= 0:
-                if line.warehouse:
-                    result[line.id] = line.warehouse.output_location.id
-                else:
-                    result[line.id] = None
-            else:
-                result[line.id] = line.sale.party.customer_location.id
-        return result
+    def get_from_location(self, name):
+        if self.quantity >= 0:
+            if self.warehouse:
+                return self.warehouse.output_location.id
+        else:
+            return self.sale.party.customer_location.id
 
-    def get_to_location(self, ids, name):
-        result = {}
-        for line in self.browse(ids):
-            if line.quantity >= 0:
-                result[line.id] = line.sale.party.customer_location.id
-            else:
-                if line.warehouse:
-                    result[line.id] = line.warehouse.input_location.id
-                else:
-                    result[line.id] = None
-        return result
+    def get_to_location(self, name):
+        if self.quantity >= 0:
+            return self.sale.party.customer_location.id
+        else:
+            if self.warehouse:
+                return self.warehouse.input_location.id
 
-    def _compute_delivery_date(self, product, date):
-        product_obj = Pool().get('product.product')
-        if product:
-            return product_obj.compute_delivery_date(product, date=date)
-        else:
-            return None
+    def on_change_with_delivery_date(self, name=None):
+        if self.product:
+            date = self.sale.sale_date if self.sale else None
+            return self.product.compute_delivery_date(date=date)
 
-    def on_change_with_delivery_date(self, values):
-        product_obj = Pool().get('product.product')
-        if values.get('product'):
-            product = product_obj.browse(values['product'])
-            return self._compute_delivery_date(product,
-                values.get('_parent_sale.sale_date'))
-        return None
+    def get_invoice_line(self, invoice_type):
+        '''
+        Return a list of invoice lines for sale line according to invoice_type
+        '''
+        pool = Pool()
+        Uom = pool.get('product.uom')
+        Property = pool.get('ir.property')
+        InvoiceLine = pool.get('account.invoice.line')
 
-    def get_delivery_date(self, ids, name):
-        dates = {}
-        for line in self.browse(ids):
-            dates[line.id] = self._compute_delivery_date(line.product,
-                line.sale.sale_date)
-        return dates
-
-    def get_invoice_line(self, line, invoice_type):
-        '''
-        Return a list of invoice line values for sale line according to
-        invoice_type
-        '''
-        uom_obj = Pool().get('product.uom')
-        property_obj = Pool().get('ir.property')
-
-        res = {}
-        res['type'] = line.type
-        res['description'] = line.description
-        res['note'] = line.note
-        if line.type != 'line':
-            if (line.sale.invoice_method == 'order'
-                    and ((all(l.quantity >= 0 for l in line.sale.lines
+        with Transaction().set_user(0, set_context=True):
+            invoice_line = InvoiceLine()
+        invoice_line.type = self.type
+        invoice_line.description = self.description
+        invoice_line.note = self.note
+        if self.type != 'line':
+            if (self.sale.invoice_method == 'order'
+                    and ((all(l.quantity >= 0 for l in self.sale.lines
                                 if l.type == 'line')
                             and invoice_type == 'out_invoice')
-                        or (all(l.quantity <= 0 for l in line.sale.lines
+                        or (all(l.quantity <= 0 for l in self.sale.lines
                                 if l.type == 'line')
                             and invoice_type == 'out_credit_note'))):
-                return [res]
+                return [invoice_line]
             else:
                 return []
 
-        if (invoice_type == 'out_invoice') != (line.quantity >= 0):
+        if (invoice_type == 'out_invoice') != (self.quantity >= 0):
             return []
 
-        if (line.sale.invoice_method == 'order'
-                or not line.product
-                or line.product.type == 'service'):
-            quantity = abs(line.quantity)
+        if (self.sale.invoice_method == 'order'
+                or not self.product
+                or self.product.type == 'service'):
+            quantity = abs(self.quantity)
         else:
             quantity = 0.0
-            for move in line.moves:
+            for move in self.moves:
                 if move.state == 'done':
-                    quantity += uom_obj.compute_qty(move.uom, move.quantity,
-                            line.unit)
+                    quantity += Uom.compute_qty(move.uom, move.quantity,
+                        self.unit)
 
-        skip_ids = set(l.id for i in line.sale.invoices_recreated
+        skip_ids = set(l.id for i in self.sale.invoices_recreated
             for l in i.lines)
-        for invoice_line in line.invoice_lines:
+        for invoice_line in self.invoice_lines:
             if invoice_line.type != 'line':
                 continue
             if invoice_line.id not in skip_ids:
-                quantity -= uom_obj.compute_qty(invoice_line.unit,
-                        invoice_line.quantity, line.unit)
-        res['quantity'] = quantity
+                quantity -= Uom.compute_qty(invoice_line.unit,
+                    invoice_line.quantity, self.unit)
+        invoice_line.quantity = quantity
 
-        if res['quantity'] <= 0.0:
+        if invoice_line.quantity <= 0.0:
             return []
-        res['unit'] = line.unit.id
-        res['product'] = line.product.id
-        res['unit_price'] = line.unit_price
-        res['taxes'] = [('set', [x.id for x in line.taxes])]
-        if line.product:
-            res['account'] = line.product.account_revenue_used.id
-            if not res['account']:
+        invoice_line.unit = self.unit
+        invoice_line.product = self.product
+        invoice_line.unit_price = self.unit_price
+        invoice_line.taxes = self.taxes
+        if self.product:
+            invoice_line.account = self.product.account_revenue_used
+            if not invoice_line.account:
                 self.raise_user_error('missing_account_revenue',
-                        error_args=(line.product.rec_name,))
+                        error_args=(self.product.rec_name,))
         else:
             for model in ('product.template', 'product.category'):
-                res['account'] = property_obj.get('account_revenue', model)
-                if res['account']:
+                invoice_line.account = Property.get('account_revenue', model)
+                if invoice_line.account:
                     break
-            if not res['account']:
+            if not invoice_line.account:
                 self.raise_user_error('missing_account_revenue_property')
-        return [res]
+        return [invoice_line]
 
-    def copy(self, ids, default=None):
+    @classmethod
+    def copy(cls, lines, default=None):
         if default is None:
             default = {}
         default = default.copy()
@@ -1470,118 +1278,104 @@
         default['moves_ignored'] = None
         default['moves_recreated'] = None
         default['invoice_lines'] = None
-        return super(SaleLine, self).copy(ids, default=default)
+        return super(SaleLine, cls).copy(lines, default=default)
 
-    def get_move(self, line, shipment_type):
+    def get_move(self, shipment_type):
         '''
-        Return move values for the sale line according ot shipment_type
+        Return moves for the sale line according ot shipment_type
         '''
-        uom_obj = Pool().get('product.uom')
+        pool = Pool()
+        Uom = pool.get('product.uom')
+        Move = pool.get('stock.move')
 
-        res = {}
-        if line.type != 'line':
+        if self.type != 'line':
             return
-        if not line.product:
+        if not self.product:
             return
-        if line.product.type == 'service':
+        if self.product.type == 'service':
             return
-        if (shipment_type == 'out') != (line.quantity >= 0):
+        if (shipment_type == 'out') != (self.quantity >= 0):
             return
 
-        if line.sale.shipment_method == 'order':
-            quantity = abs(line.quantity)
+        if self.sale.shipment_method == 'order':
+            quantity = abs(self.quantity)
         else:
             quantity = 0.0
-            for invoice_line in line.invoice_lines:
+            for invoice_line in self.invoice_lines:
                 if invoice_line.invoice.state in ('open', 'paid'):
-                    quantity += uom_obj.compute_qty(invoice_line.unit,
-                        invoice_line.quantity, line.unit)
+                    quantity += Uom.compute_qty(invoice_line.unit,
+                        invoice_line.quantity, self.unit)
 
-        skip_ids = set(x.id for x in line.moves_recreated)
-        for move in line.moves:
+        skip_ids = set(x.id for x in self.moves_recreated)
+        for move in self.moves:
             if move.id not in skip_ids:
-                quantity -= uom_obj.compute_qty(move.uom, move.quantity,
-                        line.unit)
+                quantity -= Uom.compute_qty(move.uom, move.quantity,
+                    self.unit)
         if quantity <= 0.0:
             return
-        if not line.sale.party.customer_location:
+        if not self.sale.party.customer_location:
             self.raise_user_error('customer_location_required')
-        res['quantity'] = quantity
-        res['uom'] = line.unit.id
-        res['product'] = line.product.id
-        res['from_location'] = line.from_location.id
-        res['to_location'] = line.to_location.id
-        res['state'] = 'draft'
-        res['company'] = line.sale.company.id
-        res['unit_price'] = line.unit_price
-        res['currency'] = line.sale.currency.id
-        res['planned_date'] = line.delivery_date
-        return res
-
-SaleLine()
+        with Transaction().set_user(0, set_context=True):
+            move = Move()
+        move.quantity = quantity
+        move.uom = self.unit
+        move.product = self.product
+        move.from_location = self.from_location
+        move.to_location = self.to_location
+        move.state = 'draft'
+        move.company = self.sale.company
+        move.unit_price = self.unit_price
+        move.currency = self.sale.currency
+        move.planned_date = self.delivery_date
+        return move
 
 
 class SaleLineTax(ModelSQL):
     'Sale Line - Tax'
-    _name = 'sale.line-account.tax'
+    __name__ = 'sale.line-account.tax'
     _table = 'sale_line_account_tax'
-    _description = __doc__
     line = fields.Many2One('sale.line', 'Sale Line', ondelete='CASCADE',
             select=True, required=True)
     tax = fields.Many2One('account.tax', 'Tax', ondelete='RESTRICT',
             select=True, required=True)
 
-SaleLineTax()
-
 
 class SaleLineInvoiceLine(ModelSQL):
     'Sale Line - Invoice Line'
-    _name = 'sale.line-account.invoice.line'
+    __name__ = 'sale.line-account.invoice.line'
     _table = 'sale_line_invoice_lines_rel'
-    _description = __doc__
     sale_line = fields.Many2One('sale.line', 'Sale Line', ondelete='CASCADE',
             select=True, required=True)
     invoice_line = fields.Many2One('account.invoice.line', 'Invoice Line',
             ondelete='RESTRICT', select=True, required=True)
 
-SaleLineInvoiceLine()
-
 
 class SaleLineIgnoredMove(ModelSQL):
     'Sale Line - Ignored Move'
-    _name = 'sale.line-ignored-stock.move'
+    __name__ = 'sale.line-ignored-stock.move'
     _table = 'sale_line_moves_ignored_rel'
-    _description = __doc__
     sale_line = fields.Many2One('sale.line', 'Sale Line', ondelete='CASCADE',
             select=True, required=True)
     move = fields.Many2One('stock.move', 'Move', ondelete='RESTRICT',
             select=True, required=True)
 
-SaleLineIgnoredMove()
-
 
 class SaleLineRecreatedMove(ModelSQL):
     'Sale Line - Recreated Move'
-    _name = 'sale.line-recreated-stock.move'
+    __name__ = 'sale.line-recreated-stock.move'
     _table = 'sale_line_moves_recreated_rel'
-    _description = __doc__
     sale_line = fields.Many2One('sale.line', 'Sale Line', ondelete='CASCADE',
             select=True, required=True)
     move = fields.Many2One('stock.move', 'Move', ondelete='RESTRICT',
             select=True, required=True)
 
-SaleLineRecreatedMove()
-
 
 class SaleReport(CompanyReport):
-    _name = 'sale.sale'
+    __name__ = 'sale.sale'
 
-SaleReport()
 
-
-class Template(ModelSQL, ModelView):
-    _name = 'product.template'
-
+class Template:
+    __name__ = 'product.template'
     salable = fields.Boolean('Salable', states={
             'readonly': ~Eval('active', True),
             }, depends=['active'])
